-- name: [CS] Splatoon 3 pack
-- description: Frye, Shiver and Harmony from Splatoon 3!
-- category: cs

local TEXT_MOD_NAME = "Splatoon 3 pack"

-- Stops mod from loading if Character Select isn't on
if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
    return 0
end

local E_MODEL_FRYE = smlua_model_util_get_id("frye_geo") -- Located in "actors"
local E_MODEL_SHIVER = smlua_model_util_get_id("shiver_geo") -- Located in "actors"
local E_MODEL_BIGMAN = smlua_model_util_get_id("bigman_geo") -- Located in "actors"
local E_MODEL_HARMONY = smlua_model_util_get_id("harmony_geo") -- Located in "actors"

local TEX_FRYE_ICON = get_texture_info("frye-icon") -- Located in "textures"
local TEX_SHIVER_ICON = get_texture_info("shiver-icon") -- Located in "textures"
local TEX_BIGMAN_ICON = get_texture_info("bigman-icon") -- Located in "textures"
local TEX_HARMONY_ICON = get_texture_info("harmony-icon") -- Located in "textures"

-- All Located in "actors"
local CAPTABLE_FRYE = {
    normal = smlua_model_util_get_id("frye_cap_geo"),
    wing = smlua_model_util_get_id("frye_wing_cap_geo"),
    metal = smlua_model_util_get_id("frye_metal_cap_geo"),
}
local CAPTABLE_SHIVER = {
    normal = smlua_model_util_get_id("shiver_cap_geo"),
    wing = smlua_model_util_get_id("shiver_wing_cap_geo"),
    metal = smlua_model_util_get_id("shiver_metal_cap_geo"),
}
local CAPTABLE_BIGMAN = {
    normal = smlua_model_util_get_id("bigman_cap_geo"),
    wing = smlua_model_util_get_id("bigman_wcap_geo"),
    metal = smlua_model_util_get_id("bigman_mcap_geo"),
}
local CAPTABLE_HARMONY = {
    normal = smlua_model_util_get_id("harmony_cap_geo"),
    wing = smlua_model_util_get_id("harmony_wing_cap_geo"),
    metal = smlua_model_util_get_id("harmony_metal_cap_geo"),
}

local PALETTE_FRYE = {
    [PANTS]  = "EBE1DC",
    [SHIRT]  = "FFF24B",
    [GLOVES] = "A15643",
    [SHOES]  = "EBE1DC",
    [HAIR]   = "FFF24B",
    [SKIN]   = "A15643",
    [CAP]    = "FAB034",
}
local PALETTE_SHIV = {
    [PANTS]  = "262626",
    [SHIRT]  = "482E9E",
    [GLOVES] = "FF7572",
    [SHOES]  = "262626",
    [HAIR]   = "7262A2",
    [SKIN]   = "FFCFB2",
    [CAP]    = "EBE1DC",
}
local PALETTE_BIG = {
    [PANTS]  = "ffffff",
    [SHIRT]  = "ffffff",
    [GLOVES] = "ffffff",
    [SHOES]  = "ffffff",
    [HAIR]   = "ffffff",
    [SKIN]   = "ffffff",
    [CAP]    = "59e2f2",
    [EMBLEM] = "ffffff",
}
local PALETTE_HARM = {
    [PANTS]  = "E3E382",
    [SHIRT]  = "4B4F50",
    [GLOVES] = "F8D8D0",
    [SHOES]  = "5A3DCB",
    [HAIR]   = "E76BAC",
    [SKIN]   = "F8D8D0",
    [CAP]    = "ffffff",
}
local VOICETABLE_HARM = {
    [CHAR_SOUND_LETS_A_GO] = 'paru_Kuma.ogg', -- Starting level
    [CHAR_SOUND_PUNCH_HOO] = 'paru_Naa.ogg', -- Punch 3
    [CHAR_SOUND_YAH_WAH_HOO] = {'paru_Jou.ogg', 'paru_Dai.ogg'}, -- First/Second jump sounds
    [CHAR_SOUND_HOOHOO] = 'paru_Zui.ogg', -- Third jump sound
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'paru_Shii.ogg', -- Triple jump sounds
    [CHAR_SOUND_UH] = 'paru_Bu.ogg', -- Wall bonk
    [CHAR_SOUND_HAHA] = 'paru_Puso.ogg', -- Landing triple jump
    [CHAR_SOUND_YAHOO] = 'paru_Puras.ogg', -- Long jump
    [CHAR_SOUND_DOH] = 'paru_Bu.ogg', -- Long jump wall bonk
    [CHAR_SOUND_WHOA] = 'paru_Bu.ogg', -- Grabbing ledge
    [CHAR_SOUND_WAAAOOOW] = 'paru_Nmo.ogg', -- Falling a long distance
    [CHAR_SOUND_TWIRL_BOUNCE] = 'paru_Jou.ogg', -- Bouncing off of a flower spring
    [CHAR_SOUND_GROUND_POUND_WAH] = 'paru_Nmo.ogg', 
    [CHAR_SOUND_HRMM] = 'paru_Bu.ogg', -- Lifting something
    [CHAR_SOUND_HERE_WE_GO] = 'paru_Kuma.ogg', -- Star get
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'paru_Shii.ogg', -- Throwing Bowser
--DAMAGE
    [CHAR_SOUND_ATTACKED] = 'paru_Nmo.ogg', -- Damaged
    [CHAR_SOUND_PANTING] = 'paru_Nmo.ogg', -- Low health
    [CHAR_SOUND_ON_FIRE] = 'paru_Bu.ogg', -- Burned
--SLEEP SOUNDS
    [CHAR_SOUND_IMA_TIRED] = 'paru_Jou.ogg', -- Mario feeling tired
    [CHAR_SOUND_YAWNING] = 'paru_Puso.ogg', -- Mario yawning before he sits down to sleep
--DEATH
    [CHAR_SOUND_DYING] = 'paru_Nmo.ogg', -- Dying from damage
    [CHAR_SOUND_DROWNING] = 'paru_Nmo.ogg', -- Running out of air underwater
    [CHAR_SOUND_MAMA_MIA] = 'paru_Nmo.ogg', -- Booted out of level
}
local VOICETABLE_FRYE = {
    [CHAR_SOUND_LETS_A_GO] = 'frye7.ogg', -- Starting level
    [CHAR_SOUND_PUNCH_HOO] = 'frye8.ogg', -- Punch 3
    [CHAR_SOUND_YAH_WAH_HOO] = {'frye1.ogg', 'frye5.ogg'}, -- First/Second jump sounds
    [CHAR_SOUND_HOOHOO] = 'frye8.ogg', -- Third jump sound
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'frye7.ogg', -- Triple jump sounds
    [CHAR_SOUND_UH] = 'frye3.ogg', -- Wall bonk
    [CHAR_SOUND_HAHA] = 'frye10.ogg', -- Landing triple jump
    [CHAR_SOUND_YAHOO] = 'frye8.ogg', -- Long jump
    [CHAR_SOUND_DOH] = 'frye3.ogg', -- Long jump wall bonk
    [CHAR_SOUND_WHOA] = 'frye3.ogg', -- Grabbing ledge
    [CHAR_SOUND_WAAAOOOW] = 'frye9.ogg', -- Falling a long distance
    [CHAR_SOUND_TWIRL_BOUNCE] = 'frye7.ogg', -- Bouncing off of a flower spring
    [CHAR_SOUND_GROUND_POUND_WAH] = 'frye6.ogg', 
    [CHAR_SOUND_HRMM] = 'frye3.ogg', -- Lifting something
    [CHAR_SOUND_HERE_WE_GO] = 'frye6.ogg', -- Star get
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'frye12.ogg', -- Throwing Bowser
--DAMAGE
    [CHAR_SOUND_ATTACKED] = 'frye9.ogg', -- Damaged
    [CHAR_SOUND_PANTING] = 'frye3.ogg', -- Low health
    [CHAR_SOUND_ON_FIRE] = 'frye12.ogg', -- Burned
--SLEEP SOUNDS
    [CHAR_SOUND_IMA_TIRED] = 'frye10.ogg', -- Mario feeling tired
    [CHAR_SOUND_YAWNING] = 'frye3.ogg', -- Mario yawning before he sits down to sleep
--DEATH
    [CHAR_SOUND_DYING] = 'frye9.ogg', -- Dying from damage
    [CHAR_SOUND_DROWNING] = 'frye9.ogg', -- Running out of air underwater
    [CHAR_SOUND_MAMA_MIA] = 'frye12.ogg', -- Booted out of level
}
local VOICETABLE_SHIVER = {
    [CHAR_SOUND_LETS_A_GO] = 'shiver12.ogg', -- Starting level
    [CHAR_SOUND_PUNCH_HOO] = 'shiver3.ogg', -- Punch 3
    [CHAR_SOUND_YAH_WAH_HOO] = {'shiver5.ogg', 'shiver10.ogg'}, -- First/Second jump sounds
    [CHAR_SOUND_HOOHOO] = 'shiver10.ogg', -- Third jump sound
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'shiver11.ogg', -- Triple jump sounds
    [CHAR_SOUND_UH] = 'shiver8.ogg', -- Wall bonk
    [CHAR_SOUND_HAHA] = 'shiver6.ogg', -- Landing triple jump
    [CHAR_SOUND_YAHOO] = 'shiver12.ogg', -- Long jump
    [CHAR_SOUND_DOH] = 'shiver8.ogg', -- Long jump wall bonk
    [CHAR_SOUND_WHOA] = 'shiver1.ogg', -- Grabbing ledge
    [CHAR_SOUND_WAAAOOOW] = 'shiver8.ogg', -- Falling a long distance
    [CHAR_SOUND_TWIRL_BOUNCE] = 'shiver12.ogg', -- Bouncing off of a flower spring
    [CHAR_SOUND_GROUND_POUND_WAH] = 'shiver3.ogg', 
    [CHAR_SOUND_HRMM] = 'shiver3.ogg', -- Lifting something
    [CHAR_SOUND_HERE_WE_GO] = 'shiver11.ogg', -- Star get
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'shiver13.ogg', -- Throwing Bowser
--DAMAGE
    [CHAR_SOUND_ATTACKED] = 'shiver1.ogg', -- Damaged
    [CHAR_SOUND_PANTING] = 'shiver2.ogg', -- Low health
    [CHAR_SOUND_ON_FIRE] = 'shiver8.ogg', -- Burned
--SLEEP SOUNDS
    [CHAR_SOUND_IMA_TIRED] = 'shiver1.ogg', -- Mario feeling tired
    [CHAR_SOUND_YAWNING] = 'shiver1.ogg', -- Mario yawning before he sits down to sleep
--DEATH
    [CHAR_SOUND_DYING] = 'shiver4.ogg', -- Dying from damage
    [CHAR_SOUND_DROWNING] = 'shiver4.ogg', -- Running out of air underwater
    [CHAR_SOUND_MAMA_MIA] = 'shiver8.ogg', -- Booted out of level
}
local VOICETABLE_BIGMAN = {nil}

local CSloaded = false
local function on_character_select_load()
    --Frye
    CT_FRYE = _G.charSelect.character_add("Frye", {"The Eel Deal"}, "Takkotito", {r = 255, g = 235, b = 59}, E_MODEL_FRYE, CT_MARIO, TEX_FRYE_ICON)
    _G.charSelect.character_add_caps(E_MODEL_FRYE, CAPTABLE_FRYE)
    _G.charSelect.character_add_voice(E_MODEL_FRYE, VOICETABLE_FRYE)
    _G.charSelect.character_add_palette_preset(E_MODEL_FRYE, PALETTE_FRYE)
    --Shiver
    CT_SHIVER = _G.charSelect.character_add("Shiver", {"The Cold-Blooded Bandit"}, "Takkotito", {r = 115, g = 132, b = 243}, E_MODEL_SHIVER, CT_MARIO, TEX_SHIVER_ICON)
    _G.charSelect.character_add_caps(E_MODEL_SHIVER, CAPTABLE_SHIVER)
    _G.charSelect.character_add_voice(E_MODEL_SHIVER, VOICETABLE_SHIVER)
    _G.charSelect.character_add_palette_preset(E_MODEL_SHIVER, PALETTE_SHIV)
    --Big Man
    CT_SHIVER = _G.charSelect.character_add("Big Man", {"Ay! The Hype Manta Storm,", "Alias Ian BGM"}, "Takkotito", {r = 209, g = 210, b = 210}, E_MODEL_BIGMAN, CT_MARIO, TEX_BIGMAN_ICON)
    _G.charSelect.character_add_caps(E_MODEL_BIGMAN, CAPTABLE_BIGMAN)
    _G.charSelect.character_add_voice(E_MODEL_BIGMAN, VOICETABLE_BIGMAN)
    _G.charSelect.character_add_palette_preset(E_MODEL_BIGMAN, PALETTE_BIG)
    --Harmony
    CT_HARM = _G.charSelect.character_add("Harmony", {"The lead singer of the Chirpy Chips"}, "Takkotito", {r = 233, g = 30, b = 99}, E_MODEL_HARMONY, CT_MARIO, TEX_HARMONY_ICON)
    _G.charSelect.character_add_caps(E_MODEL_HARMONY, CAPTABLE_HARMONY)
    _G.charSelect.character_add_voice(E_MODEL_HARMONY, VOICETABLE_HARM)
    _G.charSelect.character_add_palette_preset(E_MODEL_HARMONY, PALETTE_HARM)

    CSloaded = true
end

local function on_character_sound(m, sound)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_FRYE then return _G.charSelect.voice.sound(m, sound) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_SHIVER then return _G.charSelect.voice.sound(m, sound) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_HARM then return _G.charSelect.voice.sound(m, sound) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_BIGMAN then return _G.charSelect.voice.sound(m, sound) end
end

local function on_character_snore(m)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_FRYE then return _G.charSelect.voice.snore(m) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_SHIVER then return _G.charSelect.voice.snore(m) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_HARM then return _G.charSelect.voice.snore(m) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_BIGMAN then return _G.charSelect.voice.sound(m, sound) end
end


hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)